#include <stdio.h>
#include <stdlib.h>

#include "voronoi.h"

static int readsites(double **xp, double **yp, unsigned int *np)
{
   double *x, *y;
   double ax, ay;
   unsigned int num;
   unsigned int max_num = 4096*1024;
   x = (double *) malloc(max_num * sizeof(double));
   if (x == NULL)
     return -1;
   y = (double *) malloc(max_num * sizeof(double));
   if (y == NULL)
     {
	free (x);
	return -1;
     }

   num = 0;
   while ((num < max_num)
	  && (scanf("%lf %lf", &ax, &ay) != EOF))
     {
	x[num] = ax;
	y[num] = ay;
	num++;
     }

   *np = num;
   *xp = x;
   *yp = y;
   return 0;
}


int
main(int argc, char *argv[])
{
   double *x, *y;
   unsigned int num;
   Voronoi_Type *v;
   int triangulate = 1;

   if (-1 == readsites (&x, &y, &num))
     return 1;

   if (NULL == (v = voronoi_open (x, y, num)))
     {
	free (x);
	free (y);
	return 1;
     }

   voronoi(v, triangulate) ;
   voronoi_close (v);

   free (x);
   free (y);

   return (0) ;
}

